/*****************************************************************************

       COPYRIGHT (C) 2008 by ACCUWEATHER, INC.

       WARNING - Notice of Ownership and Copyright.
       These programs are the exclusive property of AccuWeather, Inc.
       They contain trade secrets and/or copyrighted materials.  Removal
       of these programs, in any form, from the business premises of
       AccuWeather, Inc. may lead to civil and criminal penalties.
       Copyright by AccuWeather, Inc.  These programs may not be
 	   reproduced electronically or by any other means under penalty
       of law.  This notice may not be removed or deleted from these
       programs.

*******************************************************************************/

function getWeatherFeed() {
	$.ajax({
		url: 'http://air2.accu-weather.com/widget/air2/weather-data.asp',
		data: 'location=' + locationString + '&metric=' + isMetric,
		type: 'GET',
		error: function() {},
		beforeSend: function() {
			$('.forecastalarm').css('display', 'none').unbind("click");
			$('#alerticon').css('display', 'none').unbind("click");
			dataInProgress = true;
		},
		success: function(xml) {
			var snow = [], snowDates = [], snowalarm = 0, snowAmount = 0;
			var ice = [], iceDates = [], icealarm = 0, iceAmount = 0;
			var rain = [], rainDates = [], rainalarm = 0, rainAmount = 0;
			var tstorm = [], tstormDates = [], tstormalarm = 0, tstormChance = 0;
			var wind = [], windDates = [], windalarm = 0, maxWind = -100;
			var gust = [], windalarm = 0, maxGust = -100;
			
			if (isMetric == 1) {
				var snowMin = 2.54
				var iceMin = 2.54
				var rainMin = 12.7
				var tstormMin = 75
				var maxWindThresh = 48
				var maxGustThresh = 64            
			} else {
				var snowMin = 1
				var iceMin = 0.1
				var rainMin = 0.5
				var tstormMin = 75
				var maxWindThresh = 30
				var maxGustThresh = 40            
			}
			
			currentCity = $(xml).find('city').text();
			currentState = $(xml).find('state').text();
			currentIcon = $(xml).find('weathericon:first').text();
			currentTemp = $(xml).find('temperature:first').text();
			currentHigh = $(xml).find('hightemperature:first').text();
			currentLow = $(xml).find('lowtemperature:first').text();	
			numAlerts = $(xml).find('watchwarnareas').attr('isactive');
			alertURL = $(xml).find('watchwarnareas > url').text();
			
			var i = 0;
			$(xml).find('day:not(:eq(5))').each(function() {
				forecastDay[i] = $(this).find('daycode').text().substr(0, 3);
				forecastIcon[i] = $(this).find('weathericon:first').text();
				forecastIcon[(i + 5)] = $(this).find('weathericon:last').text();
				forecastHigh[i] = $(this).find('hightemperature:first').text();
				forecastHigh[(i + 5)] = $(this).find('hightemperature:last').text();
				forecastLow[i] = $(this).find('lowtemperature:first').text();
				forecastLow[(i + 5)] = $(this).find('lowtemperature:last').text();
				
				snow[i] = parseFloat($(this).find('snowamount:first').text()) + parseFloat($(this).find('snowamount:last').text());
				ice[i] = parseFloat($(this).find('iceamount:first').text()) + parseFloat($(this).find('iceamount:last').text());
				rain[i] = parseFloat($(this).find('rainamount:first').text()) + parseFloat($(this).find('rainamount:last').text());
				if (parseFloat($(this).find('tstormprob:first').text()) > parseFloat($(this).find('tstormprob:last').text())) {
					tstorm[i] = parseFloat($(this).find('tstormprob:first').text());
				} else {
					tstorm[i] = parseFloat($(this).find('tstormprob:last').text());
				}
				if (parseFloat($(this).find('windspeed:first').text()) > parseFloat($(this).find('windspeed:last').text())) {
					wind[i] = parseFloat($(this).find('windspeed:first').text());
				} else {
					wind[i] = parseFloat($(this).find('windspeed:last').text());
				}
				if (parseFloat($(this).find('windgust:first').text()) > parseFloat($(this).find('windgust:last').text())) {
					gust[i] = parseFloat($(this).find('windgust:first').text());
				} else {
					gust[i] = parseFloat($(this).find('windgust:last').text());
				}
				
				i++;
			});
			
			for (var i = 0; i < 5; i++) {
				if (snow[i] > 0) {
					snowAmount += snow[i];
					snowDates.push(i + 1);
				}
				if (ice[i] > 0) {
					iceAmount += ice[i];
					iceDates.push(i + 1);
				}
				if (rain[i] > 0) {
					rainAmount += rain[i];
					rainDates.push(i + 1);
				}
				if (tstorm[i] > tstormMin) {
					tstormalarm = 1;
					tstormDates.push(i + 1);
				}
				if (wind[i] > maxWindThresh) {
					windalarm = 1;
					windDates.push(i + 1);
				}
				if (gust[i] > maxGustThresh) {
					windalarm = 1;
					windDates.push(i + 1);	
				}
			}
			
			if (snowAmount > snowMin) snowalarm = 1;
			if (iceAmount > iceMin) icealarm = 1;
			if (rainAmount > rainMin) rainalarm = 1;
			
			for (var i = 0; i < 5; i++) {
				if (snowalarm == 1) $('#alarm' + (snowDates[i])).css('display', 'inherit').click(function(e) { openFSite(e); });
				if (icealarm == 1) $('#alarm' + (iceDates[i])).css('display', 'inherit').click(function(e) { openFSite(e); });
				if (rainalarm == 1) $('#alarm' + (rainDates[i])).css('display', 'inherit').click(function(e) { openFSite(e); });
				if (tstormalarm == 1) $('#alarm' + (tstormDates[i])).css('display', 'inherit').click(function(e) { openFSite(e); });
				if (windalarm == 1) $('#alarm' + (windDates[i])).css('display', 'inherit').click(function(e) { openFSite(e); });
			}

			numAlarms = snowalarm + icealarm + rainalarm + tstormalarm + windalarm;
			
			if (currentState.length > 2) { 
				isInternational = true;
			} else { 
				isInternational = false; 
			}
			
			dataInProgress = false;
			updateConditions();
		}
	});
}

function updateConditions() {
	$('#weathericon').attr('src', 'images/icons/' + iconPreference + '/' + currentIcon + '.png');
	$('#currenttemp, #currenttemps').html(currentTemp + '\u00B0');
	$('#city, #citys').html(currentCity);
	$('#cityhighlight').css('width', parseInt($('#city').width() + 15 + 'px'));
	$('#currenthigh, #currenthighs').html('H: ' + currentHigh + '\u00B0');
	$('#currentlow, #currentlows').html('L: ' + currentLow + '\u00B0');
	
	var n = 1;
	for (var i = time; i < (time + 5); i++) {
		$('#day' + n).html(forecastDay[n - 1]);
		$('#imageicon' + n).attr('src', 'images/icons/' + iconPreference + '/small/' + forecastIcon[i] + '.png').click(function(e) { openFSite(e); });
		$('#high' + n + ', #high' + n + 's').html(forecastHigh[i] + '\u00B0');
		$('#low' + n + ', #low' + n + 's').html(forecastLow[i] + '\u00B0');
		n++;
	}
	
	if (numAlerts > 0) {
		$('#alerticon').css('display', 'inherit').click(function() {
			var request = new air.URLRequest(alertURL);
			air.navigateToURL(request);
		});	
	}
}

function setLoading() {
	$('#citys, #city').html('Loading...');
	$('#cityhighlight').css('width', parseInt($('#city').width() + 15 + 'px'));
	$('#currenttemps, #currenttemp, #currenthighs, #currenthigh, #currentlows, #currentlow, .forecasthighs, .forecasthigh, .forecastlows, .forecastlow').html('--\u00B0');
	$('#weathericon, .imageicon').attr('src', 'images/blank.png');
}

function openSite(i) {
	var link;
	if (isInternational == true) {
		var strLocation = locationString;
		while (strLocation.indexOf("|") > -1) {
    		strLocation = strLocation.replace("|", "%7C");
   	 	}
		link = "http://www.accuweather.com/world-forecast-details.asp?partner=air2&locCode=" + strLocation + "&fday=" + i;
	} else { 
		link = "http://www.accuweather.com/forecast-details.asp?partner=air2&zipcode=" + locationString + "&fday=" + i;
	}
	var request = new air.URLRequest(link);
	air.navigateToURL(request);
}

function openFSite(event) {
	var i = $(event.target).attr('id');
	i = i.substr(-1);
	var link;
	if (isInternational == 1) {
		var strLocation = locationString;
		while (strLocation.indexOf("|") > -1) {
    		strLocation = strLocation.replace("|", "%7C");
   	 	}
		link = "http://www.accuweather.com/world-forecast-details.asp?partner=air2&locCode=" + strLocation + "&fday=" + i;
	} else { 
		link = "http://www.accuweather.com/forecast-details.asp?partner=air2&zipcode=" + locationString + "&fday=" + i;
	}
	var request = new air.URLRequest(link);
	air.navigateToURL(request);
}