/*****************************************************************************

       COPYRIGHT (C) 2008 by ACCUWEATHER, INC.

       WARNING - Notice of Ownership and Copyright.
       These programs are the exclusive property of AccuWeather, Inc.
       They contain trade secrets and/or copyrighted materials.  Removal
       of these programs, in any form, from the business premises of
       AccuWeather, Inc. may lead to civil and criminal penalties.
       Copyright by AccuWeather, Inc.  These programs may not be
 	   reproduced electronically or by any other means under penalty
       of law.  This notice may not be removed or deleted from these
       programs.

*******************************************************************************/

var conn = new air.SQLConnection();
var create;
var insert;
var update;
var select;
var remove;

var dbFile = air.File.applicationStorageDirectory.resolvePath("stratus1.db");
conn.open(dbFile);

function createDatabase() {
	create = new air.SQLStatement();
	create.sqlConnection = conn;
	
	var sql = "CREATE TABLE weather ( ";
		sql += "id INTEGER PRIMARY KEY AUTOINCREMENT, ";
		sql += "name TEXT, ";
		sql += "code TEXT, ";
		sql += "metric TEXT, ";
		sql += "selected TEXT,";
		sql += "alert TEXT";
		sql += ")";
	create.text = sql;	
	create.execute();
	
	sql = "CREATE TABLE preference ( ";
	sql += "id INTEGER PRIMARY KEY AUTOINCREMENT,";
	sql += "always INTEGER,";
	sql += "start INTEGER,";
	sql += "icon TEXT,";
	sql += "background INTEGER,";
	sql += "xposition INTEGER,";
	sql += "yposition INTEGER,";
	sql += "taskbar INTEGER";     // ADDED ON 4/21/09 for Stratus1.1
	sql += ")";
	create = new air.SQLStatement();
	create.sqlConnection = conn;
	create.text = sql;
	create.execute();
	
	insert = new air.SQLStatement();
	insert.sqlConnection = conn;
	sql = "INSERT INTO weather (name, code, metric, selected) VALUES ('New York, NY', '10001', '0', '1')";
	insert.text = sql;
	insert.execute();
	
	insert = new air.SQLStatement();
	insert.sqlConnection = conn;
	sql = "INSERT INTO preference (id, always, start, icon, background, xposition, yposition, taskbar) VALUES (0, 0, 1, 'real', 1, 50, 50, 0)";
	insert.text = sql;
	insert.execute();
	
	locationString = 10001;
	languagePreference = 0;
	alwaysPreference = 0;
	startPreference = 1;
	taskbarPreference = 0;
}

function updateDatabase() {
	// To be used to update preference table for Stratus1.1
	var sql = "ALTER TABLE preference ADD COLUMN taskbar INTEGER";
	insert = new air.SQLStatement();
	insert.sqlConnection = conn;
	insert.text = sql;
	insert.execute();
	
	update = new air.SQLStatement();
	var sql = "UPDATE preference SET taskbar = 0";
	update.sqlConnection = conn;
	update.text = sql;
	update.execute();
}

function clearCurrentDatabase() {
	remove = new air.SQLStatement();
	remove.sqlConnection = conn;
	var sql = 'DELETE FROM weather WHERE code = "' + locationString + '"';
	remove.text = sql;
	remove.execute();
	
	select = new air.SQLStatement();
	select.sqlConnection = conn;
	var sql = "SELECT * FROM weather ORDER BY id DESC LIMIT 1";
	select.text = sql;
	select.execute();
	
	var result = select.getResult();
	locationString = result.data[0]['code'];
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE weather SET selected = 1 WHERE id = '" + result.data[0]['id'] + "'";
	update.text = sql;
	update.execute();
	
	getWeatherFeed();
}

function clearRecentDatabase() {
	remove = new air.SQLStatement();
	remove.sqlConnection = conn;
	var sql = 'DELETE FROM weather WHERE code != "' + locationString + '"';
	remove.text = sql;
	remove.execute();
}

function selectRecentLocation(event) {
	try {
		var name = event.target.label;
	} catch(e) {
		var name = event;	
	}
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE weather SET selected = '0' WHERE selected = '1'";
	update.text = sql;
	update.execute();
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = 'UPDATE weather SET selected = 1 WHERE name = "' + name + '"';
	update.text = sql;
	update.execute();

	select = new air.SQLStatement();
	select.sqlConnection = conn;
	var sql = 'SELECT * FROM weather WHERE name = "' + name + '"';
	select.text = sql;
	select.execute();
	
	var result = select.getResult();
	locationString = result.data[0]['code'];
	
	if (result.data[0]['metric'] == 1) {
		isMetric = 1;
		$('#iconc').attr('src', 'images/pref/c.png');
		$('#iconf').attr('src', 'images/pref/foff.png');
	} else {
		isMetric = 0;
		$('#iconf').attr('src', 'images/pref/f.png');
		$('#iconc').attr('src', 'images/pref/coff.png');
	}
	
	setLoading();
	getWeatherFeed();
}

function updateDatabaseMetric(a) {
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = 'UPDATE weather SET metric = "' + a + '" WHERE code = "' + locationString + '"';
	update.text = sql;
	update.execute();
}

function insertLocation(name, code) {
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE weather SET selected = '0' WHERE selected = '1'";
	update.text = sql;
	update.execute();
	
	select = new air.SQLStatement();
	select.sqlConnection = conn;
	var sql = 'SELECT * FROM weather WHERE code = "' + code + '"';
	select.text = sql;
	select.execute();
	var result = select.getResult();

	if (result.data == null) {
		insert = new air.SQLStatement();
		insert.sqlConnection = conn;
		var sql = 'INSERT INTO weather (name, code, metric, selected) VALUES ("' + name + '", "' + code + '", 0, 1)';
		insert.text = sql;
		insert.execute();
	} else {
		selectRecentLocation(name);
	}
}