/*************************************************************
AccuWeather WeatherAlarm - For Adobe AIR v1.0+
If fair weather, prepare for foul

Rick Harrison, Michael Sylvie, and Carl Schaad

Date			Author			Modification
Aug 19, 2008	Rick Harrison	Weather AIR v1.0 Started
Nov 3, 2008		Rick Harrison	Weather AIR v1.0 Beta Finished
Feb 17, 2009 	Rick Harrison	AccuWeather.com Stratus v1.0 Launch
*************************************************************/

/*****************************************************************************

       COPYRIGHT (C) 2008 by ACCUWEATHER, INC.

       WARNING - Notice of Ownership and Copyright.
       These programs are the exclusive property of AccuWeather, Inc.
       They contain trade secrets and/or copyrighted materials.  Removal
       of these programs, in any form, from the business premises of
       AccuWeather, Inc. may lead to civil and criminal penalties.
       Copyright by AccuWeather, Inc.  These programs may not be
 	   reproduced electronically or by any other means under penalty
       of law.  This notice may not be removed or deleted from these
       programs.

*******************************************************************************/

//Global Variable Declarations
var feedURL;
var locationString; 
var isMetric		= 0;
var currentCity 	= "";
var currentState 	= "";
var currentLocation = "";
var currentTemp 	= 1;
var currentIcon 	= "";
var currentHigh 	= 0;
var currentLow 		= 0;
var forecastDay 	= new Array();
var forecastHigh    = new Array();
var forecastLow     = new Array();
var forecastIcon 	= new Array();
var numAlarms 		= 0;
var numAlerts		= 0;
var alertURL		= "";
var isInternational	= new Boolean(false);
var isExpanded 		= new Boolean(false);
var mainTimer 		= new air.Timer(15 * 60 * 1000, 0);
var alwaysPreference = 0;
var startPreference = 1;
var taskbarPreference = 0;
var iconPreference = "real";
var bgPreference = 1;
var xPreference = 30;
var yPreference = 30;
var time = 0;
var appUpdater;
var dataInProgress = new Boolean(false);

var weather = function() {
	function build() {
		try {
			createDatabase();
		} catch(e) {
			try {
				updateDatabase(); // To update to include taskbar preference as of Stratus1.1
			} catch(e) {}
			
			select = new air.SQLStatement();
			select.sqlConnection = conn;
			select.text = "SELECT * FROM weather WHERE selected = 1";
			select.execute();
		
			var result = select.getResult();
			locationString = result.data[0].code;
			if (result.data[0].metric == 1) {
				isMetric = 1;
			} else {
				isMetric = 0;
			}
			
			select = new air.SQLStatement();
			select.sqlConnection = conn;
			select.text = "SELECT * FROM preference";
			select.execute();
			
			var result = select.getResult();
			alwaysPreference = result.data[0].always;
			startPreference = result.data[0].start;
			taskbarPreference = result.data[0].taskbar;
			iconPreference = result.data[0].icon;
			bgPreference = result.data[0].background;
			xPreference = result.data[0].xposition;
			yPreference = result.data[0].yposition;
		}

		setPreferences();
		setEvents();

		mainTimer.addEventListener(air.TimerEvent.TIMER, function() {
			air.trace('updating');
			try { getWeatherFeed(); } catch(e) {}
		});
		mainTimer.start();
		getWeatherFeed();
		
		$('body').mousedown(function(e) {
			if ((e.pageX > 144) && (e.pageX < 196) && (e.pageY > 42) && (e.pageY < 99) && (parseInt($('#prefscreen').css('opacity')) > 0)) {} else {
				if (e.button == 0) {
					nativeWindow.startMove();
					nativeWindow.addEventListener("move", function() {
						$('#currenticon').unbind("click");
						$('body').unbind("mouseup").one("mouseup", function() {
							$('#currenticon').unbind("click").click(function() { controlIcon(); });
							saveWidgetPosition();
						});
					});
				} else if (e.button == 2) {
					displayRightMenu(e);
				}
			}
		});
	
		$('#closebutton').attr('src', 'images/close_win.png').css({
			top: '7px',
			left: '5px'
		}).hover(function() {
			$(this).attr('src', 'images/close_win_on.png');
		}, function() {
			$(this).attr('src', 'images/close_win.png');
		});
		$('#minimizebutton').attr('src', 'images/minimize_win.png').css({
			top: '9px',
			left: '20px'
		}).hover(function() {
			$(this).attr('src', 'images/minimize_win_on.png');
		}, function() {
			$(this).attr('src', 'images/minimize_win.png');
		});
		
		nativeWindow.addEventListener(window.runtime.flash.events.NativeWindowDisplayStateEvent.DISPLAY_STATE_CHANGE, checkMinimize);
		
		nativeWindow.addEventListener(air.Event.CLOSING, closeWidget);
		
		initUpdate();
	}
	
	function setEvents() {
		controlElements(); // FROM ui.js
		setHomeEvents(); // FROM ui.js
		
		$('#day').click(function() {
			if (!dataInProgress) {
				$('#day').attr('src', 'images/day.png');
				$('#night').attr('src', 'images/nightoff.png');
				time = 0;
				updateConditions();
			}
		});
		$('#night').click(function() {
			if (!dataInProgress) {
				$('#day').attr('src', 'images/dayoff.png');
				$('#night').attr('src', 'images/night.png');
				time = 5;
				updateConditions();
			}
		});
	}
	
	function setPreferences() {
		var newx = parseInt((air.Screen.mainScreen.bounds.width * xPreference) / 100);
		var newy = parseInt((air.Screen.mainScreen.bounds.height * yPreference) / 100);
		
		nativeWindow.bounds = new air.Rectangle(newx, newy, 200, 100);

		if (nativeWindow.bounds.x < 0 || nativeWindow.bounds.x > air.Screen.mainScreen.bounds.width) {
			newx = parseInt(air.Screen.mainScreen.bounds.width * .5);
		}
		
		if (nativeWindow.bounds.y < 0 || nativeWindow.bounds.y > air.Screen.mainScreen.bounds.height) {
			newy = parseInt(air.Screen.mainScreen.bounds.height * .5);
		}
		
		nativeWindow.bounds = new air.Rectangle(newx, newy, 200, 100);
		
		$('#' + iconPreference).attr('src', 'images/pref/' + iconPreference + '.png');
		
		if (isMetric == 1) {
			$('#iconc').attr('src', 'images/pref/c.png');
		} else {
			$('#iconf').attr('src', 'images/pref/f.png');
		}
		
		updateBackground(bgPreference);
		
		nativeWindow.alwaysInFront = alwaysPreference;
		try {
			air.NativeApplication.nativeApplication.startAtLogin = (startPreference == 1) ? true : false;
		} catch(e) {}
		air.NativeApplication.nativeApplication.autoExit = true;
		
		if (air.NativeApplication.supportsSystemTrayIcon) {
			if (taskbarPreference == 0) goToTray();
			else setupTray();
		}
	}
	
	function goToTaskbar() {
		var options = new air.NativeWindowInitOptions();
		options.systemChrome = air.NativeWindowSystemChrome.NONE;
		options.transparent = true;
		options.resizable = false;
		options.maximizable = false;
		options.minimizable = true;
		options.type = "normal";
		var bounds = new air.Rectangle(nativeWindow.x, nativeWindow.y, 200, 100);
		var html = air.HTMLLoader.createRootWindow(true, options, false, bounds);
		html.load(new air.URLRequest("index.html"));
		var newWindow = html.stage.nativeWindow;
		//newWindow.addEventListener(air.Event.CLOSE, cleanUpClose);
		
		nativeWindow.close();
		
		if (nativeWindow.type == "normal") setupTray();
	}
	
	function goToTray() {
		if (nativeWindow.type != "lightweight") {
			var options = new air.NativeWindowInitOptions();
			options.systemChrome = air.NativeWindowSystemChrome.NONE;
			options.transparent = true;
			options.resizable = false;
			options.maximizable = false;
			options.minimizable = true;
			options.type = "lightweight";
			var bounds = new air.Rectangle(nativeWindow.x, nativeWindow.y, 200, 100);  // -190 +90 |||| +90 +30 (out || in)
			var html = air.HTMLLoader.createRootWindow(true, options, false, bounds);
			html.load(new air.URLRequest("index.html"));
			var newWindow = html.stage.nativeWindow;
			//newWindow.addEventListener(air.Event.CLOSE, cleanUpClose);
			
			nativeWindow.close();
		}
		
		if (nativeWindow.type == "lightweight") setupTrayLightweight();
	}
	
	function initUpdate() {
		appUpdater = new air.ApplicationUpdaterUI();
		appUpdater.configurationFile = new air.File("app:/update.xml");
		appUpdater.addEventListener(air.ErrorEvent.ERROR, onError);
		appUpdater.initialize();
	}
	
	function onError(event) {
		alert(event.toString());
	}
	
	function saveWidgetPosition() {
		var screenWidth = parseInt(air.Screen.mainScreen.bounds.width);
		var screenHeight = parseInt(air.Screen.mainScreen.bounds.height);
		var appX = parseInt(window.nativeWindow.bounds.x);
		var appY = parseInt(window.nativeWindow.bounds.y);
		var xpercent = parseInt((appX / screenWidth) * 100);
		var ypercent = parseInt((appY / screenHeight) * 100);
		
		update = new air.SQLStatement();
		update.sqlConnection = conn;
		var sql = "UPDATE preference SET xposition = '" + xpercent + "', yposition = '" + ypercent + "' WHERE id = '0'";
		update.text = sql;
		update.execute();
	}
	
	return {
		build:build,
		goToTaskbar:goToTaskbar,
		goToTray:goToTray
	}
}();