/*****************************************************************************

       COPYRIGHT (C) 2008 by ACCUWEATHER, INC.

       WARNING - Notice of Ownership and Copyright.
       These programs are the exclusive property of AccuWeather, Inc.
       They contain trade secrets and/or copyrighted materials.  Removal
       of these programs, in any form, from the business premises of
       AccuWeather, Inc. may lead to civil and criminal penalties.
       Copyright by AccuWeather, Inc.  These programs may not be
 	   reproduced electronically or by any other means under penalty
       of law.  This notice may not be removed or deleted from these
       programs.

*******************************************************************************/

var menu;
var seperator = new air.NativeMenuItem("", true);
var modified = 0;

$(document).ready(function() {
	$('#ibutton').click(function() {
		openPreferences();
	});
	
	$('#magnify').click(function() {
		getCityFeed();							 
	});
	
	$('#savebutton').click(function() {
		if (($('#searchterm').attr('value') != "Input Location Here") && ($('#searchterm').attr('value') != "")) {
			getCityFeed();
		} else {
			closePreferences();
		}
	});
	
	$('#cancelbutton').click(function() {
		$('#searchterm').attr('value', 'Input Location Here');						  
									  
		$('#cancelbutton, #savebutton').animate({
			opacity: 0
		}, {
			duration: 300,
			complete: function() {
				$('#savebutton').attr('src', 'images/donebutton.png').animate({
					opacity: 1														  
				}, {
					duration: 300,
					complete: function() {
						$('#savebutton').unbind("click").click(function() {
							if ($('#searchterm').attr('value') != "Input Location Here") {
								getCityFeed();
							} else {
								closePreferences();
							}
						});	
					}
				});	
			}
		});
		
		modified = 0;
	});
	
	$(window).unbind("keypress").keypress(function() {
		if(event.keyCode == 13) {
			if (air.Capabilities.os.indexOf("Mac") < 0) getCityFeed();
			$(this).unbind("keypress");
		} else {
			if (($('#searchterm').attr('value') != "Input Location Here") && modified == 0) {
				$('#savebutton').animate({
					opacity: 0					 
				}, {
					duration: 300,
					complete: function() {
						$('#savebutton').attr('src', 'images/searchbutton.png');
						$('#savebutton, #cancelbutton').css('display', 'inherit').animate({
							opacity: 1									
						}, {
							duration: 300,
							complete: function() {
								
							}
						});
					}
				});
				
				modified = 1;
			}
		}
	});
	
	$('#searchterm').focus(function() {
		if ($(this).attr('value') == "Input Location Here" || $(this).attr('value') == "No Location Found") {
			$(this).attr('value', '');	
		}
		
		$(this).css('border', 'none');
	});
	
	$('#real').click(function() {
		updateIcon("real", "styled");					  
	});
	$('#styled').click(function() {
		updateIcon("styled", "real");						
	});
	
	$('#iconc').click(function() {
		updateMetric(1);					   
	});
	$('#iconf').click(function() {
		updateMetric(0);					   
	});
	
	$('#iconwhite').click(function() {
		updateBackground(1);						   
	});
	$('#iconblack').click(function() {
		updateBackground(0);						   
	});
});

function openPreferences() {
	if (isExpanded == true) {
		$('#forecastbutton').trigger("click");	
	}
	
	$('#homescreen').animate({
		opacity: 0
	}, {
		duration: 300,
		complete: function() {
			$(this).css('display', 'none');
			$('#prefscreen').css('display', 'inherit').animate({
				opacity: 1
			}, {
				duration: 300
			});	
		}
	});
}

function closePreferences() {
	$('#prefscreen').animate({
		opacity: 0
	}, {
		duration: 300,
		complete: function() {
			$(this).css('display', 'none');
			
			$('#searchterm').attr('value', 'Input Location Here');
			
			$('#homescreen').css('display', 'inherit').animate({
				opacity: 1
			}, {
				duration: 300,
				complete: function() {
					$('#cityhighlight').css('width', parseInt($('#city').width() + 15 + 'px'));
				}
			});	
			
			$('#savebutton').unbind("click").click(function() {
				if (($('#searchterm').attr('value') != "Input Location Here") && ($('#searchterm').attr('value') != "")) {
					getCityFeed();
				} else {
					closePreferences();
				}
			});
			
			$('#cancelbutton').css({ opacity: 0, display: 'none' });
			$('#savebutton').attr('src', 'images/donebutton.png');
			modified = 0;
		}
	});
}

function getCityFeed() {
	$.ajax({
		url: 'http://air2.accu-weather.com/widget/air2/city-find.asp?location=' + $('#searchterm').attr('value'),
		type: 'GET',
		dataType: 'xml',
		beforeSend: function() {
			$('#savebutton').unbind("click");
			$('#searchterm').attr('value', 'Searching...');
		},
		error: function() {
			$('searchterm').attr('value', 'Error: Please Try Again');	
		},
		success: function(xml) {
			var numCities = $(xml).find('location');
			var currentSelectLocation = "";
			var currentName = "";
			var hasSelected = 0;
			
			if (numCities.length == 0) {
				$('#searchterm').attr('value', 'No Location Found');
				$('#savebutton').unbind("click").click(function() {
					if ($('#searchterm').attr('value') != "No Location Found") {
						getCityFeed();
					} else {
						closePreferences();
					}
				});
			} else {
				menu = new air.NativeMenu();
				
				$(xml).find('location').each(function() {
					var city = $(this).attr('city');
					var state = $(this).attr('state');
					var templocation = $(this).attr('location');
					var item = new air.NativeMenuItem(city + ', ' + state, false);
					item.addEventListener(air.Event.SELECT, function() {
						var name = city + ', ' + state;
						changeMenu(name, templocation);
						hasSelected = 1;
						$('#savebutton').attr('src', 'images/donebutton.png');
					});
					menu.addItem(item);
				});
				
				function changeMenu(name, templocation) {
					$('#searchterm').attr('value', name);
					currentSelectLocation = templocation;
					currentName = name;
				}
				
				$('#savebutton').unbind("click").click(function() {
					if (hasSelected == 1) {
						saveLocation(currentSelectLocation, currentName);
					} else {
						getCityFeed();	
					}
				});
				
				menu.display(window.nativeWindow.stage, 10, 60);
				
				$(window).unbind("keypress").keypress(function() {
					if(event.keyCode == 13) {
						$(this).unbind("keypress");
						if (air.Capabilities.os.indexOf("Mac") < 0) getCityFeed();	
					} else {
						if (($('#searchterm').attr('value') != "Input Location Here") && modified == 0) {
							$('#savebutton').animate({
								opacity: 0					 
							}, {
								duration: 300,
								complete: function() {
									$('#savebutton').attr('src', 'images/searchbutton.png');
									$('#savebutton, #cancelbutton').css('display', 'inherit').animate({
										opacity: 1									
									}, {
										duration: 300,
										complete: function() {
											
										}
									});
								}
							});
							
							modified = 1;
						}
					}
				});
			}
		}
	});
}

function saveLocation(newLocation, newName) {
	insertLocation(newName, newLocation);
	locationString = newLocation;
	setLoading();
	getWeatherFeed();
	closePreferences();
}

function updateIcon(newpref, old) {
	$('#' + newpref).attr('src', 'images/pref/' + newpref + '.png');
	$('#' + old).attr('src', 'images/pref/' + old + 'off.png');
	
	iconPreference = newpref;
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE preference SET icon = '" + newpref + "'";
	update.text = sql;
	update.execute();
	
	updateConditions();
}

function updateMetric(value) {
	updateDatabaseMetric(value);
	isMetric = value;
	if (value == 1) {
		$('#iconc').attr('src', 'images/pref/c.png');
		$('#iconf').attr('src', 'images/pref/foff.png');
	} else {
		$('#iconf').attr('src', 'images/pref/f.png');
		$('#iconc').attr('src', 'images/pref/coff.png');
	}
	setLoading();
	getWeatherFeed();
}

function updateBackground(value) {
	bgPreference = value;
	if (value == 1) {
		$('#iconwhite').attr('src', 'images/pref/white.png');
		$('#iconblack').attr('src', 'images/pref/blackoff.png');
		$('body').css('color', "#FFFFFF");
		$('#adclogo').attr('src', 'images/logowhite.png');
		$('.ashadow, .forecasthighs').css('display', 'inherit');
	} else {
		$('#iconwhite').attr('src', 'images/pref/whiteoff.png');
		$('#iconblack').attr('src', 'images/pref/black.png');
		$('body').css('color', "#000000");
		$('#adclogo').attr('src', 'images/logoblack.png');
		$('.ashadow, .forecasthighs').css('display', 'none');
	}
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE preference SET background = '" + value + "'";
	update.text = sql;
	update.execute();
}