/*****************************************************************************

       COPYRIGHT (C) 2008 by ACCUWEATHER, INC.

       WARNING - Notice of Ownership and Copyright.
       These programs are the exclusive property of AccuWeather, Inc.
       They contain trade secrets and/or copyrighted materials.  Removal
       of these programs, in any form, from the business premises of
       AccuWeather, Inc. may lead to civil and criminal penalties.
       Copyright by AccuWeather, Inc.  These programs may not be
 	   reproduced electronically or by any other means under penalty
       of law.  This notice may not be removed or deleted from these
       programs.

*******************************************************************************/

var rightMenu;
var alwaysMenu;
var startMenu;
var seperator = new air.NativeMenuItem("", true);
var xPlace = (air.Screen.mainScreen.bounds.width / 2) - 184;
var yPlace = (air.Screen.mainScreen.bounds.height / 2) - 97;

function displayRightMenu(e) {
	rightMenu = new air.NativeMenu();
	
	var change = new air.NativeMenuItem("Change Location", false);
	change.addEventListener(air.Event.SELECT, openPreferences);
	rightMenu.addItem(change);
	
	var help = new air.NativeMenuItem("Help", false);
	help.addEventListener(air.Event.SELECT, openHelp);
	rightMenu.addItem(help);
	
	rightMenu.addItem(new air.NativeMenuItem("", true));

	rightMenu.addSubmenu(displayAlwaysMenu(), "Always On Top");
	rightMenu.addSubmenu(displayStartMenu(), "Start Application At Login");
	if (air.NativeApplication.supportsSystemTrayIcon) rightMenu.addSubmenu(displayTaskbarMenu(), "Display in Taskbar");
	
	rightMenu.addItem(new air.NativeMenuItem("", true));
	
	var hide = new air.NativeMenuItem("Hide Widget", false);
	hide.addEventListener(air.Event.SELECT, hideWidget);
	rightMenu.addItem(hide);
	
	var close = new air.NativeMenuItem("Close Widget", false);
	close.addEventListener(air.Event.SELECT, closeWidget);
	rightMenu.addItem(close);
	
	rightMenu.display(window.nativeWindow.stage, e.clientX, e.clientY);
}

function displayAlwaysMenu() {
	alwaysMenu = new air.NativeMenu();
	
	var yes = new air.NativeMenuItem("Yes", false);
	yes.addEventListener(air.Event.SELECT, function() {
		selectNewAlways(1);
	});
	alwaysMenu.addItem(yes);
	
	var no = new air.NativeMenuItem("No", false);
	no.addEventListener(air.Event.SELECT, function() {
		selectNewAlways(0);
	});
	alwaysMenu.addItem(no);
	
	if (alwaysPreference == "1") {
		yes.checked = true;
	} else {
		no.checked = true;
	}
	
	return alwaysMenu;
}

function displayStartMenu() {
	startMenu = new air.NativeMenu();
	
	var yes = new air.NativeMenuItem("Yes", false);
	yes.addEventListener(air.Event.SELECT, function() {
		selectNewStart(1);
	});
	startMenu.addItem(yes);
	
	var no = new air.NativeMenuItem("No", false);
	no.addEventListener(air.Event.SELECT, function() {
		selectNewStart(0);
	});
	startMenu.addItem(no);
	
	if (startPreference == "1") {
		yes.checked = true;
	} else {
		no.checked = true;
	}
	
	return startMenu;
}

function displayTaskbarMenu() {
	var taskbarMenu = new air.NativeMenu();
	
	var yes = new air.NativeMenuItem("Yes", false);
	yes.addEventListener(air.Event.SELECT, function() {
		selectNewTaskbar(1);
	});
	taskbarMenu.addItem(yes);
	
	var no = new air.NativeMenuItem("No", false);
	no.addEventListener(air.Event.SELECT, function() {
		selectNewTaskbar(0);
	});
	taskbarMenu.addItem(no);
	
	if (taskbarPreference == "1") {
		yes.checked = true;
	} else {
		no.checked = true;
	}
	
	return taskbarMenu;
}

function selectNewAlways(input) {
	alwaysPreference = input;
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE preference SET always = '" + input + "'";
	update.text = sql;
	update.execute();
	
	nativeWindow.alwaysInFront = input;
}

function selectNewStart(input) {
	startPreference = input;
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE preference SET start = '" + input + "'";
	update.text = sql;
	update.execute();
	
	air.NativeApplication.nativeApplication.startAtLogin = input;
}

function selectNewTaskbar(input) {
	taskbarPreference = input;
	
	update = new air.SQLStatement();
	update.sqlConnection = conn;
	var sql = "UPDATE preference SET taskbar = '" + input + "'";
	update.text = sql;
	update.execute();
	
	if (input == 1) weather.goToTaskbar();
	if (input == 0) weather.goToTray();
}

function openHelp() {
	var link = "http://www.accuweather.com/adobe-air/doc/stratus-help.pdf";
	var request = new air.URLRequest(link);
	air.navigateToURL(request);
}